/* create_gnuplot.c */

#include <stdio.h>
#include <math.h>

int create_movie(int n);

int create_movie(int n)
{
  static int i;

  FILE *file, *file1, *file2;

  file = fopen("prog_movie", "w");
 
  // fprintf(file, "set terminal pbm color \n");  

  fprintf(file, "set terminal png \n");  
  fprintf(file, "set parametric \n");  
  fprintf(file, "set cntrparam levels 40 \n");
  fprintf(file, "set cntrparam bspline \n");
  fprintf(file, "set pointsize 0.1 \n");
  fprintf(file, "set contour base \n");
  fprintf(file, "set view 0,90 \n");
  fprintf(file, "set nosurface \n");
  fprintf(file, "set noxtics \n");
  fprintf(file, "set noytics \n");
  fprintf(file, "set noztics \n");
  fprintf(file, "set nolabel \n");
  fprintf(file, "set noclabel \n");  

  // fprintf(file, "set linestyle 9 lt 9 lw 5 \n");
  // fprintf(file, "set linestyle 9 \n");

  fprintf(file, "set style line 1 \n");

  for(i = 0; i < n; i++) { 
    // fprintf(file, "set output \"convection%d.pbm\" \n", i);  

    fprintf(file, "set output \"convection%d.png\" \n", i);  
    fprintf(file, "splot \"PCELL%d.DAT\" notitle w l 9 \n", i);
    fflush(file);
  }

  fprintf(file, "quit \n");
  fclose(file);
  
  file1 = fopen("Movie", "w");

  fprintf(file1, "#mpeg_encode parameter file \n\n");  
  fprintf(file1, "PATTERN IPBIPBIPBIPB \n");  
  fprintf(file1, "OUTPUT convection.mpg \n\n");  
  fprintf(file1, "YUV_SIZE 400x400 \n\n");  
  fprintf(file1, "BASE_FILE_FORMAT PPM \n");  
  fprintf(file1, "INPUT_CONVERT * \n");  
  fprintf(file1, "GOP_SIZE 10 \n");  
  fprintf(file1, "SLICES_PER_FRAME 1 \n\n");  
  fprintf(file1, "INPUT_DIR /home/frutos/PCELL \n\n");  
  fprintf(file1, "INPUT \n");  

  for(i = 0; i < n - 3; i++) {
    fprintf(file1, "convection%d.ppm\n", i);  
    fflush(file1);
  }

  fprintf(file1, "convection%d.ppm \n", n - 2);  
  fprintf(file1, "convection%d.ppm \n", n - 3);  
  fprintf(file1, "convection%d.ppm \n", n - 1);  
  
  fprintf(file1, "END_INPUT \n\n");  
  fprintf(file1, "PIXEL HALF \n");  
  fprintf(file1, "RANGE 8 \n");  
  fprintf(file1, "PSEARCH_ALG LOGARITHMIC \n");  
  fprintf(file1, "BSEARCH_ALG SIMPLE \n\n");  
  fprintf(file1, "IQSCALE  8 \n");  
  fprintf(file1, "PQSCALE 10 \n");  
  fprintf(file1, "BQSCALE 25 \n\n");  
  fprintf(file1, "REFERENCE_FRAME ORIGINAL \n\n");  
  fprintf(file1, "#end parameter file \n");  
  fclose(file1);

  file2 = fopen("convertion", "w");

  for(i = 0; i < n; i++) {
    fprintf(file2, "convert convection%d.pbm convection%d.ppm \n", i, i); 
  }

  fclose(file2);
  
  return 0;
}








